// ProductManager.cpp: implementation of the CProductManager class.
//
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "CustomDrawing.h"
#include "ProductManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include <Dapfor/Common/LongEnumFormat.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CProductManager::CProductManager()
{

}

CProductManager::~CProductManager()
{

}

double CProductManager::GetUnitPrice(Product product)
{
    //Of course, this can be loaded from the database.
    switch(product)
    {
        case USBHub:      return 57.14;
        case Webcam:      return 12.01;
        case Microphone:  return 24.87;
        case BlurayDrive: return 457;
        case CdRom:       return 23.23;
        case Modem:       return 112.05;

        default:
            ASSERT(FALSE); //The product is not known
            return 0;      //Or we can throw an exception
    }
}


Dapfor::Common::CFormat& CProductManager::GetProductFormat()
{
    //Static declaration of the table
    static Dapfor::Common::CLongEnumFormat::Item products[] =
    {
        {CProductManager::USBHub,       _T("USB Hub")},
        {CProductManager::Webcam,       _T("Webcam")},
        {CProductManager::Microphone,   _T("Microphone")},
        {CProductManager::BlurayDrive,  _T("Blu-ray Drive")},
        {CProductManager::CdRom,        _T("CD ROM Drive")},
        {CProductManager::Modem,        _T("Modem")},
    };      

    //Static declaration of the format. 
    //The format will be created only once at the moment when this function will be called for the first time.
    static Dapfor::Common::CLongEnumFormat format(products, sizeof(products)/sizeof(products[0]));
    
    //return a reference to the format
    return format;
}


