// GridBenchmark.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "GridBenchmark.h"

#include "MainFrm.h"

#include <Dapfor/Common/Timer.h>

using namespace Dapfor;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGridBenchmarkApp

BEGIN_MESSAGE_MAP(CGridBenchmarkApp, CWinApp)
    //{{AFX_MSG_MAP(CGridBenchmarkApp)
    ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGridBenchmarkApp construction

CGridBenchmarkApp::CGridBenchmarkApp()
    : m_OnIdleOptimization(TRUE)
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGridBenchmarkApp object

CGridBenchmarkApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CGridBenchmarkApp initialization

BOOL CGridBenchmarkApp::InitInstance()
{
    //Initialize non-GUI timer before CMainFrame creating
    Common::CTimer::Initialize();


    // To create the main window, this code creates a new frame window
    // object and then sets it as the application's main window object.

    CMainFrame* pFrame = new CMainFrame;
    m_pMainWnd = pFrame;

    // create and load the frame with its resources

    pFrame->LoadFrame(IDR_MAINFRAME,
        WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
        NULL);




    // The one and only window has been initialized, so show and update it.
    pFrame->ShowWindow(SW_SHOW);
    pFrame->UpdateWindow();

    
    return TRUE;
}



int CGridBenchmarkApp::ExitInstance() 
{
    return CWinApp::ExitInstance();

    
    Common::CTimer::UnInitialize();
}


/////////////////////////////////////////////////////////////////////////////
// CGridBenchmarkApp message handlers
void CGridBenchmarkApp::SetOnIdleOptimization(BOOL enable)
{
    m_OnIdleOptimization = enable;
}

BOOL CGridBenchmarkApp::GetOnIdleOptimization() const
{
    return m_OnIdleOptimization;
}


BOOL CGridBenchmarkApp::OnIdle(LONG lCount) 
{
    //OnIdle optimization.
    if(m_OnIdleOptimization)
    {
        static long lastTick = GetTickCount();
        long currentTick = GetTickCount();
        long distance = currentTick - lastTick;
        if(distance < 0) distance = -distance;
        
        
        //OnIdle is called in the default message loop when the application's message queue is empty
        //The default implementation of OnIdle updates command user-interface objects such as menu items and toolbar buttons.
        //This call is enough expensive. So, call the function of the base class at last at last after 10 ms.
        //We'll call the function at last after 10 ms.
        if(distance > 10)
        {
            lastTick = currentTick;
            return CWinApp::OnIdle(lCount);
        }

        //No more OnIdle needed.
        return 0;   
    }
    else
    {
        return CWinApp::OnIdle(lCount);
    }
}



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

protected:
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    //{{AFX_VIRTUAL(CAboutDlg)
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CGridBenchmarkApp::OnAppAbout()
{
    CAboutDlg aboutDlg;
    aboutDlg.DoModal();
}

